
/* Portions Copyright (c) 1995,1996,1997 by Trusted Information Systems, Inc.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND TRUSTED INFORMATION SYSTEMS DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL TRUSTED INFORMATION 
 * SYSTEMS BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 *
 * Trusted Information Systems, Inc. has received approval from the
 * United States Government for export and reexport of TIS/DNSSEC
 * software from the United States of America under the provisions of
 * the Export Administration Regulations (EAR) General Software Note
 * (GSN) license exception for mass market software.  Under the
 * provisions of this license, this software may be exported or
 * reexported to all destinations except for the embargoed countries of
 * Cuba, Iran, Iraq, Libya, North Korea, Sudan and Syria.  Any export
 * or reexport of TIS/DNSSEC software to the embargoed countries
 * requires additional, specific licensing approval from the United
 * States Government. 
 */




#ifndef RSAREF_LINK_H
/* $Header: /home/ogud/sec_bind/dnssec_lib/RCS/rsaref_link.h,v 1.10 1997/01/22 21:29:54 ogud Exp $ */
#define RSAREF_LINK_H

# ifdef RSAREF
#  ifdef __STDC__
#    define PROTOTYPES 1
#  else
#    define PROTOTYPES 0
#  endif

#  include <global.h>
#  include <rsaref.h>

typedef struct rsakey {
  char              *signer;
  R_RSA_PRIVATE_KEY *Private_Key;
  R_RSA_PUBLIC_KEY  *Public_Key;
  R_SIGNATURE_CTX    context[2];
} RSA_Key;

int       rsa_sign           __P(( int, R_SIGNATURE_CTX *, u_char *, int,
				   R_RSA_PRIVATE_KEY *, u_char *));
int       rsa_verify         __P(( int, R_SIGNATURE_CTX *, u_char *, int,
				   R_RSA_PUBLIC_KEY *, u_char *, int));
int       rsa_cmp            __P(( RSA_Key *, RSA_Key *));
int       dns2rsakey         __P(( int, u_char *, u_char *, KEY *));
int       rsa2dnskey         __P(( R_RSA_PUBLIC_KEY *, char *, int));

int       Encode_RSAKey      __P(( R_RSA_PRIVATE_KEY *, char *, int ));
int       Decode_RSAKey      __P(( RSA_Key *, char *, int ));
int       Generate_RSAKey    __P(( KEY *, int));
void      Free_RSAKey        __P(( RSA_Key *));

int       des_function       __P(( u_char *, u_char *, u_char *, int, int));
# endif
#endif 
